
proc rescode { res code {msg ""} } {
	global news 

	set val [string range $res 0 2]
	if { $val != $code } {
		if { $msg == "" } {
			set msg "Bad return code!\nExpected $code got $res"
		}
		set ok [tk_dialog .xxerr "$news(tclnews) $news(version)"  $msg error 0 OK]
		return 1
	} else {
		return 0
	}
}

proc socksend { s v } {
	global news

	if { $news(debug) == 1 } {
		debugmsg "SEND: $s ($v)"
	}
	if { [catch {puts $s $v} msg ] == 1 } {
		tk_dialog .xxerr "$news(tclnews) $news(version)"  "Error write to socket $s\n($msg)" error 0 OK
	 	disconnect $s
		return
	}
	flush $s
}

proc closesocket s {
	close $s
}

proc sleep {} {
	global sleepval
	incr sleepval
#	puts "Sleep($sleepval)"
}

proc readsock s {
	global sleepval news

	set sleepval 0
	if { [catch {gets $s} tmp] == -1 }  {
		if { $news(debug) == 1 } {
			debugmsg "RECV ERROR: $s ($tmp)"
		}
		return ""
	}
	while { [fblocked $s] == 1 } {
		after 700 {sleep}
		vwait sleepval
		set tmp [gets $s]
	}
	if { $news(debug) == 1 } {
		debugmsg "RECV: $s ($tmp)"
	}
	return $tmp
}
	

proc connectit { } {
	global news buffers


	set ts [clock format [clock seconds] -format %H%M%S]

	#  If we have a main connection and it's not in use
	#  then use it now otherwise, create a new connection.
	if { $news(main) != "" && ![info exists news(main,proc)] } {
		set news(main,proc) $ts
		update
		if { $news(main,proc) == $ts } {
			return $news(main)
		}
	}
 
	if { [catch {socket $news(serv) nntp} sock] == 1 } {
		tk_dialog .xxerr "$news(tclnews) $news(version)" \
			"Can't create another connection to $news(serv)!\n($sock)." error 0 OK 
			return ""

	}
	fconfigure $sock -buffering line
	fconfigure $sock -blocking off
	fconfigure $sock -translation crlf 

	# Check for a good connection
	set res [readsock $sock]
	set val [string range $res 0 2]
	if { $val != "200" } {
		disconnect $sock
		tk_dialog .xxerr "$news(tclnews) $news(version)" \
			"Can't create another connection to $news(serv)!\nReceived ($res)." question 0 OK 
			return ""
	}

      	if { $news(nntpuser) != "" } {
		#  Password required
      		socksend $sock "authinfo user $news(nntpuser)"
		if { [rescode [readsock $sock] 381] == 0 } {
			# Auth required
			if { $news(nntppass) == "" } {
				set news(nntppass) [getpassword "News (NNTP)"]
			}
			socksend $sock "authinfo pass $news(nntppass)"
			if { [rescode [readsock $sock] 281] == 1 } {
				set news(nntppass) ""
			        close $sock
				return ""
			}
		     }
	}

	if { ![info exists news(xover)] } {
		socksend $sock "xover 111"
		set resp [readsock $sock]
		set val [string range $resp 0 2]

		# 412 not in news group if supported
		if { $val == "412" } {
			set news(xover) 1
		} else {
			set news(xover) 0
		}
	}
	if { $news(main) == "" } {
		set news(main,proc) $ts
		update
		if { $news(main,proc) == $ts } {
			set news(main) $sock
		}
	}
	return $sock
}

proc disconnect sock {
	global news

	catch {fileevent $sock readable ""}
	catch {fileevent $sock writable ""}
	if { $news(main) == $sock } {
		catch {unset news(main,proc)} msg
		#  Get rid of any input in this channel
		while { [fblocked $sock] == 0 } {
			gets $sock
		}
		return
	}
	closesocket $sock
}

